#include <windows.h>
#include "VolumousePlugin.h"



BOOL WINAPI DllMain(
  HINSTANCE hinstDLL,
  DWORD fdwReason,
  LPVOID lpvReserved
)
{

	return TRUE;
}

WCHAR PluginName[] = L"HideThisApp";
WCHAR HideShowComponentName[] = L"Hide/Show Active Window";

#define MAX_HIDDEN_WINDOWS 256

static HWND hHiddenWindows[MAX_HIDDEN_WINDOWS] = {0};
static int iWindowIndex = 0;

void HideActiveWindow()
{
	if (iWindowIndex < MAX_HIDDEN_WINDOWS - 1)
	{
		HWND hActiveWindow = GetForegroundWindow();

		if (hActiveWindow != NULL)
		{
			ShowWindow(hActiveWindow, SW_HIDE);
			hHiddenWindows[iWindowIndex] = hActiveWindow;
			iWindowIndex++;
		}
	}

}

BOOL ShowHiddenWindow()
{
	if (iWindowIndex > 0)
	{
		iWindowIndex--;
		ShowWindow(hHiddenWindows[iWindowIndex], SW_SHOW);		
		SetForegroundWindow(hHiddenWindows[iWindowIndex]);
		return TRUE;
	}
	else
		return FALSE;
}

void ShowAllHiddenWindow()
{
	while (ShowHiddenWindow())
	{

	}
}


INT_PTR WINAPI VolumousePluginProc(VOLUMOUSE_PLUGIN_EVENT *pEvent)
{
	INT_PTR result = FALSE;

	switch(pEvent->EventID)
	{
		case VOLUPLUGIN_EVENT_LOAD:
			//This event is fired when the plugin is loaded into Volumouse.

			pEvent->Load.PluginName = PluginName;
			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_UNLOAD:
			//This event is fired when the plugin is unloaded from Volumouse.
			//Show back all hidden Windows before we exit from Volumouse
			//If we don't do that, the windows will remain hidden forever...
			ShowAllHiddenWindow();
			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_ADD_COMPONENTS:
			//This event is fired when Volumouse need to display the components list.
			//Add our 2 components to the components list of Volumouse.
			pEvent->AddComponents.Count = 1;
			pEvent->AddComponents.Components[0] = HideShowComponentName;
			
			result = TRUE;


			break;

		case VOLUPLUGIN_EVENT_USER_ACTION:
			//This event is fired when the user moves the wheel or press
			//the hot key combination, according to the defined rules.

			if (pEvent->UserAction.ComponentIndex == 0)
			{

				if (pEvent->UserAction.Change > 0)
					HideActiveWindow();
				else 
					ShowHiddenWindow();

				result = TRUE;
			}
			break;
	}

	return result;
}